#!/usr/bin/env node
"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
require("source-map-support/register");
const minimist_1 = __importDefault(require("minimist"));
const input_1 = require("./input");
const merge_1 = require("./merge");
const output_1 = require("./output");
// Validate input arguments
const args = (0, minimist_1.default)(process.argv);
(0, input_1.validateArgs)(args);
const inputs = (0, input_1.getInputDataFromArgs)(args);
// Generate output
const output = (0, merge_1.mergeInputs)(inputs);
if (args.p || args.print) {
    // Print summary to output
    const lineCoverage = parseFloat(output.coverage[0]['line-rate']) * 100;
    const branchCoverage = parseFloat(output.coverage[0]['branch-rate']) * 100;
    console.log(`Total line Coverage: ${lineCoverage.toFixed(2)}%`);
    console.log(`Total branch Coverage: ${branchCoverage.toFixed(2)}%`);
    console.log(`Total average Coverage: ${((lineCoverage + branchCoverage) / 2).toFixed(2)}%`);
}
if (args.o) {
    // Write resulting xml to file
    (0, output_1.writeOutput)(args.o, output);
}
//# sourceMappingURL=index.js.map