"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const chai_1 = __importStar(require("chai"));
const chai_almost_1 = __importDefault(require("chai-almost"));
const chai_arrays_1 = __importDefault(require("chai-arrays"));
const merge_1 = require("../src/merge");
const data_1 = require("./data");
chai_1.default.use((0, chai_almost_1.default)(100));
chai_1.default.use(chai_arrays_1.default);
describe('mergeInputs', () => {
    it('should merge a single empty file', () => {
        const output = (0, merge_1.mergeInputs)([data_1.EMPTY_INPUT_FILE]);
        (0, chai_1.expect)(output.coverage.length).to.equal(1);
        (0, chai_1.expect)(output.coverage[0]['line-rate']).to.equal(data_1.EMPTY_INPUT_FILE.data.coverage[0]['line-rate']);
        (0, chai_1.expect)(output.coverage[0]['branch-rate']).to.equal(data_1.EMPTY_INPUT_FILE.data.coverage[0]['branch-rate']);
        (0, chai_1.expect)(output.coverage[0]['lines-covered']).to.equal(data_1.EMPTY_INPUT_FILE.data.coverage[0]['lines-covered']);
        (0, chai_1.expect)(output.coverage[0]['lines-valid']).to.equal(data_1.EMPTY_INPUT_FILE.data.coverage[0]['lines-valid']);
        (0, chai_1.expect)(output.coverage[0]['branches-covered']).to.equal(data_1.EMPTY_INPUT_FILE.data.coverage[0]['branches-covered']);
        (0, chai_1.expect)(output.coverage[0]['branches-valid']).to.equal(data_1.EMPTY_INPUT_FILE.data.coverage[0]['branches-valid']);
        (0, chai_1.expect)(output.coverage[0].complexity).to.equal(data_1.EMPTY_INPUT_FILE.data.coverage[0].complexity);
        (0, chai_1.expect)(parseInt(output.coverage[0].timestamp, 10)).to.be.almost(Date.now(), 100);
        (0, chai_1.expect)(output.coverage[0].sources).to.be.array();
        (0, chai_1.expect)(output.coverage[0].sources.length).to.equal(1);
        (0, chai_1.expect)(output.coverage[0].sources[0].source.length).to.equal(1);
        (0, chai_1.expect)(output.coverage[0].sources[0].source[0].$t).to.equal(process.cwd());
        (0, chai_1.expect)(output.coverage[0].packages).to.be.array();
        (0, chai_1.expect)(output.coverage[0].packages.length).to.equal(1);
        (0, chai_1.expect)(output.coverage[0].packages[0].package).to.be.array();
        (0, chai_1.expect)(output.coverage[0].packages[0].package.length).to.equal(0);
    });
    it('should merge two files into a single file', () => {
        const output = (0, merge_1.mergeInputs)([data_1.INPUT_FILE1, data_1.INPUT_FILE2]);
        const totalLinesCovered = parseInt(data_1.INPUT_FILE1.data.coverage[0]['lines-covered'], 10) +
            parseInt(data_1.INPUT_FILE2.data.coverage[0]['lines-covered'], 10);
        const totalLinesValid = parseInt(data_1.INPUT_FILE1.data.coverage[0]['lines-valid'], 10) +
            parseInt(data_1.INPUT_FILE2.data.coverage[0]['lines-valid'], 10);
        const totalBranchesCovered = parseInt(data_1.INPUT_FILE1.data.coverage[0]['branches-covered'], 10) +
            parseInt(data_1.INPUT_FILE2.data.coverage[0]['branches-covered'], 10);
        const totalBranchesValid = parseInt(data_1.INPUT_FILE1.data.coverage[0]['branches-valid'], 10) +
            parseInt(data_1.INPUT_FILE2.data.coverage[0]['branches-valid'], 10);
        const complexity = Math.max(parseInt(data_1.INPUT_FILE1.data.coverage[0].complexity, 10), parseInt(data_1.INPUT_FILE2.data.coverage[0].complexity, 10));
        (0, chai_1.expect)(output.coverage.length).to.equal(1);
        (0, chai_1.expect)(output.coverage[0]['line-rate']).to.equal((totalLinesCovered / totalLinesValid).toString());
        (0, chai_1.expect)(output.coverage[0]['branch-rate']).to.equal((totalBranchesCovered / totalBranchesValid).toString());
        (0, chai_1.expect)(output.coverage[0]['lines-covered']).to.equal(totalLinesCovered.toString());
        (0, chai_1.expect)(output.coverage[0]['lines-valid']).to.equal(totalLinesValid.toString());
        (0, chai_1.expect)(output.coverage[0]['branches-covered']).to.equal(totalBranchesCovered.toString());
        (0, chai_1.expect)(output.coverage[0]['branches-valid']).to.equal(totalBranchesValid.toString());
        (0, chai_1.expect)(output.coverage[0].complexity).to.equal(complexity.toString());
        (0, chai_1.expect)(parseInt(output.coverage[0].timestamp, 10)).to.be.almost(Date.now(), 100);
        (0, chai_1.expect)(output.coverage[0].sources).to.be.array();
        (0, chai_1.expect)(output.coverage[0].sources.length).to.equal(1);
        (0, chai_1.expect)(output.coverage[0].sources[0].source.length).to.equal(1);
        (0, chai_1.expect)(output.coverage[0].sources[0].source[0].$t).to.equal(process.cwd());
        (0, chai_1.expect)(output.coverage[0].packages).to.be.array();
        (0, chai_1.expect)(output.coverage[0].packages.length).to.equal(1);
        (0, chai_1.expect)(output.coverage[0].packages[0].package).to.be.array();
        (0, chai_1.expect)(output.coverage[0].packages[0].package.length).to.equal(2);
        // Validate first output package
        (0, chai_1.expect)(output.coverage[0].packages[0].package[0].name).to.equal(`${data_1.INPUT_FILE1.packageName}.${data_1.INPUT_FILE1.data.coverage[0].packages[0].package[0].name}`);
        (0, chai_1.expect)(output.coverage[0].packages[0].package[0]['line-rate']).to.equal(data_1.INPUT_FILE1.data.coverage[0].packages[0].package[0]['line-rate']);
        (0, chai_1.expect)(output.coverage[0].packages[0].package[0]['branch-rate']).to.equal(data_1.INPUT_FILE1.data.coverage[0].packages[0].package[0]['branch-rate']);
        (0, chai_1.expect)(output.coverage[0].packages[0].package[0].complexity).to.equal(data_1.INPUT_FILE1.data.coverage[0].packages[0].package[0].complexity);
        (0, chai_1.expect)(data_1.INPUT_FILE1.data.coverage[0].packages[0].package[0].classes).to.not.equal(null);
        (0, chai_1.expect)(output.coverage[0].packages[0].package[0].classes).to.deep.equal(data_1.INPUT_FILE1.data.coverage[0].packages[0].package[0].classes.map((inputClasses) => ({
            class: inputClasses.class.map(inputClass => (Object.assign(Object.assign({}, inputClass), { filename: data_1.INPUT_FILE1.data.coverage[0].sources[0].source[0].$t + '/' + inputClass.filename })))
        })));
        // Validate second output package
        (0, chai_1.expect)(output.coverage[0].packages[0].package[1].name).to.equal(data_1.INPUT_FILE2.packageName);
        (0, chai_1.expect)(output.coverage[0].packages[0].package[1]['line-rate']).to.equal(data_1.INPUT_FILE2.data.coverage[0].packages[0].package[0]['line-rate']);
        (0, chai_1.expect)(output.coverage[0].packages[0].package[1]['branch-rate']).to.equal(data_1.INPUT_FILE2.data.coverage[0].packages[0].package[0]['branch-rate']);
        (0, chai_1.expect)(output.coverage[0].packages[0].package[1].complexity).to.equal(data_1.INPUT_FILE2.data.coverage[0].packages[0].package[0].complexity);
        (0, chai_1.expect)(data_1.INPUT_FILE2.data.coverage[0].packages[0].package[0].classes).to.not.equal(null);
        (0, chai_1.expect)(output.coverage[0].packages[0].package[1].classes).to.deep.equal(data_1.INPUT_FILE2.data.coverage[0].packages[0].package[0].classes.map((inputClasses) => ({
            class: inputClasses.class.map(inputClass => (Object.assign(Object.assign({}, inputClass), { filename: data_1.INPUT_FILE2.data.coverage[0].sources[0].source[0].$t + '/' + inputClass.filename })))
        })));
    });
    it('should merge two files, one of which has no packages but classes at the root, into a single file', () => {
        const output = (0, merge_1.mergeInputs)([data_1.INPUT_FILE2, data_1.INPUT_FILE_WITH_ROOT_CLASSES]);
        const totalLinesCovered = parseInt(data_1.INPUT_FILE2.data.coverage[0]['lines-covered'], 10) +
            parseInt(data_1.INPUT_FILE_WITH_ROOT_CLASSES.data.coverage[0]['lines-covered'], 10);
        const totalLinesValid = parseInt(data_1.INPUT_FILE2.data.coverage[0]['lines-valid'], 10) +
            parseInt(data_1.INPUT_FILE_WITH_ROOT_CLASSES.data.coverage[0]['lines-valid'], 10);
        const totalBranchesCovered = parseInt(data_1.INPUT_FILE2.data.coverage[0]['branches-covered'], 10) +
            parseInt(data_1.INPUT_FILE_WITH_ROOT_CLASSES.data.coverage[0]['branches-covered'], 10);
        const totalBranchesValid = parseInt(data_1.INPUT_FILE2.data.coverage[0]['branches-valid'], 10) +
            parseInt(data_1.INPUT_FILE_WITH_ROOT_CLASSES.data.coverage[0]['branches-valid'], 10);
        const complexity = Math.max(parseInt(data_1.INPUT_FILE2.data.coverage[0].complexity, 10), parseInt(data_1.INPUT_FILE_WITH_ROOT_CLASSES.data.coverage[0].complexity, 10)).toString();
        const lineRate = (totalLinesCovered / totalLinesValid).toString();
        const brancheRate = (totalBranchesCovered / totalBranchesValid).toString();
        (0, chai_1.expect)(output.coverage.length).to.equal(1);
        (0, chai_1.expect)(output.coverage[0]['line-rate']).to.equal(lineRate);
        (0, chai_1.expect)(output.coverage[0]['branch-rate']).to.equal(brancheRate);
        (0, chai_1.expect)(output.coverage[0]['lines-covered']).to.equal(totalLinesCovered.toString());
        (0, chai_1.expect)(output.coverage[0]['lines-valid']).to.equal(totalLinesValid.toString());
        (0, chai_1.expect)(output.coverage[0]['branches-covered']).to.equal(totalBranchesCovered.toString());
        (0, chai_1.expect)(output.coverage[0]['branches-valid']).to.equal(totalBranchesValid.toString());
        (0, chai_1.expect)(output.coverage[0].complexity).to.equal(complexity);
        (0, chai_1.expect)(parseInt(output.coverage[0].timestamp, 10)).to.be.almost(Date.now(), 100);
        (0, chai_1.expect)(output.coverage[0].sources[0].source.length).to.equal(1);
        (0, chai_1.expect)(output.coverage[0].sources[0].source[0].$t).to.equal(process.cwd());
        (0, chai_1.expect)(output.coverage[0].packages).to.be.array();
        (0, chai_1.expect)(output.coverage[0].packages.length).to.equal(1);
        (0, chai_1.expect)(output.coverage[0].packages[0].package).to.be.array();
        (0, chai_1.expect)(output.coverage[0].packages[0].package.length).to.equal(2);
        // Validate first package
        (0, chai_1.expect)(output.coverage[0].packages[0].package[0].name).to.equal(data_1.INPUT_FILE2.packageName);
        (0, chai_1.expect)(output.coverage[0].packages[0].package[0]['line-rate']).to.equal(data_1.INPUT_FILE2.data.coverage[0].packages[0].package[0]['line-rate']);
        (0, chai_1.expect)(output.coverage[0].packages[0].package[0]['branch-rate']).to.equal(data_1.INPUT_FILE2.data.coverage[0].packages[0].package[0]['branch-rate']);
        (0, chai_1.expect)(output.coverage[0].packages[0].package[0].complexity).to.equal(data_1.INPUT_FILE2.data.coverage[0].packages[0].package[0].complexity);
        (0, chai_1.expect)(data_1.INPUT_FILE2.data.coverage[0].packages[0].package[0].classes).to.not.equal(null);
        (0, chai_1.expect)(output.coverage[0].packages[0].package[0].classes).to.deep.equal(data_1.INPUT_FILE2.data.coverage[0].packages[0].package[0].classes.map((inputClasses) => ({
            class: inputClasses.class.map(inputClass => (Object.assign(Object.assign({}, inputClass), { filename: data_1.INPUT_FILE2.data.coverage[0].sources[0].source[0].$t + '/' + inputClass.filename })))
        })));
        // Validate second package
        (0, chai_1.expect)(output.coverage[0].packages[0].package[1].name).to.equal(data_1.INPUT_FILE_WITH_ROOT_CLASSES.packageName);
        (0, chai_1.expect)(output.coverage[0].packages[0].package[1]['line-rate']).to.equal(lineRate);
        (0, chai_1.expect)(output.coverage[0].packages[0].package[1]['branch-rate']).to.equal(brancheRate);
        (0, chai_1.expect)(output.coverage[0].packages[0].package[1].complexity).to.equal(complexity);
        (0, chai_1.expect)(output.coverage[0].packages[0].package[1].classes).to.deep.equal(data_1.INPUT_FILE_WITH_ROOT_CLASSES.data.coverage[0].packages[0].class.map(jsonClass => ({
            class: [
                Object.assign(Object.assign({}, jsonClass), { filename: data_1.INPUT_FILE_WITH_ROOT_CLASSES.data.coverage[0].sources[0].source[0].$t + '/' + jsonClass.filename })
            ]
        })));
    });
    it('should merge two files, one of which has a package but no classes, into a single file', () => {
        const output = (0, merge_1.mergeInputs)([data_1.INPUT_FILE2, data_1.EMPTY_INPUT_FILE_WITHOUT_CLASSES]);
        const totalLinesCovered = parseInt(data_1.INPUT_FILE2.data.coverage[0]['lines-covered'], 10) +
            parseInt(data_1.EMPTY_INPUT_FILE_WITHOUT_CLASSES.data.coverage[0]['lines-covered'], 10);
        const totalLinesValid = parseInt(data_1.INPUT_FILE2.data.coverage[0]['lines-valid'], 10) +
            parseInt(data_1.EMPTY_INPUT_FILE_WITHOUT_CLASSES.data.coverage[0]['lines-valid'], 10);
        const totalBranchesCovered = parseInt(data_1.INPUT_FILE2.data.coverage[0]['branches-covered'], 10) +
            parseInt(data_1.EMPTY_INPUT_FILE_WITHOUT_CLASSES.data.coverage[0]['branches-covered'], 10);
        const totalBranchesValid = parseInt(data_1.INPUT_FILE2.data.coverage[0]['branches-valid'], 10) +
            parseInt(data_1.EMPTY_INPUT_FILE_WITHOUT_CLASSES.data.coverage[0]['branches-valid'], 10);
        const complexity = Math.max(parseInt(data_1.INPUT_FILE2.data.coverage[0].complexity, 10), parseInt(data_1.EMPTY_INPUT_FILE_WITHOUT_CLASSES.data.coverage[0].complexity, 10)).toString();
        const lineRate = (totalLinesCovered / totalLinesValid).toString();
        const branchRate = (totalBranchesCovered / totalBranchesValid).toString();
        (0, chai_1.expect)(output.coverage.length).to.equal(1);
        (0, chai_1.expect)(output.coverage[0]['line-rate']).to.equal(lineRate);
        (0, chai_1.expect)(output.coverage[0]['branch-rate']).to.equal(branchRate);
        (0, chai_1.expect)(output.coverage[0]['lines-covered']).to.equal(totalLinesCovered.toString());
        (0, chai_1.expect)(output.coverage[0]['lines-valid']).to.equal(totalLinesValid.toString());
        (0, chai_1.expect)(output.coverage[0]['branches-covered']).to.equal(totalBranchesCovered.toString());
        (0, chai_1.expect)(output.coverage[0]['branches-valid']).to.equal(totalBranchesValid.toString());
        (0, chai_1.expect)(output.coverage[0].complexity).to.equal(complexity);
        (0, chai_1.expect)(parseInt(output.coverage[0].timestamp, 10)).to.be.almost(Date.now(), 100);
        (0, chai_1.expect)(output.coverage[0].sources[0].source.length).to.equal(1);
        (0, chai_1.expect)(output.coverage[0].sources[0].source[0].$t).to.equal(process.cwd());
        (0, chai_1.expect)(output.coverage[0].packages).to.be.array();
        (0, chai_1.expect)(output.coverage[0].packages.length).to.equal(1);
        (0, chai_1.expect)(output.coverage[0].packages[0].package).to.be.array();
        (0, chai_1.expect)(output.coverage[0].packages[0].package.length).to.equal(2);
        // Validate first package
        (0, chai_1.expect)(output.coverage[0].packages[0].package[0].name).to.equal(data_1.INPUT_FILE2.packageName);
        (0, chai_1.expect)(output.coverage[0].packages[0].package[0]['line-rate']).to.equal(data_1.INPUT_FILE2.data.coverage[0].packages[0].package[0]['line-rate']);
        (0, chai_1.expect)(output.coverage[0].packages[0].package[0]['branch-rate']).to.equal(data_1.INPUT_FILE2.data.coverage[0].packages[0].package[0]['branch-rate']);
        (0, chai_1.expect)(output.coverage[0].packages[0].package[0].complexity).to.equal(data_1.INPUT_FILE2.data.coverage[0].packages[0].package[0].complexity);
        (0, chai_1.expect)(data_1.INPUT_FILE2.data.coverage[0].packages[0].package[0].classes).to.not.equal(null);
        (0, chai_1.expect)(output.coverage[0].packages[0].package[0].classes).to.deep.equal(data_1.INPUT_FILE2.data.coverage[0].packages[0].package[0].classes.map((inputClasses) => ({
            class: inputClasses.class.map(inputClass => (Object.assign(Object.assign({}, inputClass), { filename: data_1.INPUT_FILE2.data.coverage[0].sources[0].source[0].$t + '/' + inputClass.filename })))
        })));
        // Validate second package
        (0, chai_1.expect)(output.coverage[0].packages[0].package[1].name).to.equal(`${data_1.EMPTY_INPUT_FILE_WITHOUT_CLASSES.packageName}.${data_1.EMPTY_INPUT_FILE_WITHOUT_CLASSES.data.coverage[0].packages[0].package[0].name}`);
        (0, chai_1.expect)(output.coverage[0].packages[0].package[1]['line-rate']).to.equal(data_1.EMPTY_INPUT_FILE_WITHOUT_CLASSES.data.coverage[0].packages[0].package[0]['line-rate']);
        (0, chai_1.expect)(output.coverage[0].packages[0].package[1]['branch-rate']).to.equal(data_1.EMPTY_INPUT_FILE_WITHOUT_CLASSES.data.coverage[0].packages[0].package[0]['branch-rate']);
        (0, chai_1.expect)(output.coverage[0].packages[0].package[1].complexity).to.equal(data_1.EMPTY_INPUT_FILE_WITHOUT_CLASSES.data.coverage[0].packages[0].package[0].complexity);
    });
});
//# sourceMappingURL=merge.js.map